/* ClassStatus.C <-- class status definitions. */

#include <string.h>
#include "classes.h"
#include "../src/lang.h"

char* time2str (the_board& game)
 {
 static char ch[20]; ch[0] = 0;
 char *ptr = ch;
 int i;
 const int diff = (int) difftime(time(NULL), game.start);
 i = (diff / 3600);
   ptr += sprintf(ptr, "T:%02d:", i);
 i = (diff%3600) / 60;
   ptr += sprintf(ptr, "%02d:", i);
 i = (diff%60);
   ptr += sprintf(ptr, "%02d", i);
 return ch;
 }

void status::time_update (the_board &game)
 {
 mvwprintw(statuswin, 0,game.Xsize*4-28, "<%s>", time2str(game)); 
 wrefresh(statuswin);
 }

void status::make_basic (the_board &game)
 {
 bas[0] = 0;
 char *ptr = bas;
 ptr += sprintf(ptr, "<G:%02dx%02d>", game.Xsize,game.Ysize);
 ptr += sprintf(ptr, "<B:%03d>", game.total);   
 if (game.defaults.surface == 1)
   ptr += sprintf(ptr, "<EU>");
 else if (game.defaults.surface == 2) 
   ptr += sprintf(ptr, "<KL>");
 else if (game.defaults.surface == 3) 
   ptr += sprintf(ptr, "<TR>");   
 if (game.defaults.ai == 1) 
   ptr += sprintf(ptr, "<AI>");
 }

void status::make_all (the_board& game)
 {
 werase(statuswin);
 mvwprintw(statuswin, 0,0, bas);
 mvwprintw(statuswin, 0,(game.Xsize*4-strlen(ext))/2-2 , ext);
 mvwprintw(statuswin, 0,game.Xsize*4-28, "<%s>", time2str(game));
 mvwprintw(statuswin, 0,game.Xsize*4-16, "<CV:%04d>",game.Xsize*game.Ysize-game.uncovered-game.cracked);
 mvwprintw(statuswin, 0,game.Xsize*4-7, "<LF:%03d>",(-game.cracked+game.total<-99)?-99:game.total-game.cracked);
 wrefresh(statuswin);
 }

void status::string (const char *input, the_board& game)
 {
 strcpy(ext,input);
 make_all (game);
 }

void status::copyright (the_board &game)
 {
 if (game.Xsize*4-49 < 25)
	 string(S_("copyright",game.defaults.lang), game);
 else if (game.Xsize*4-49 < 30)
	 string(M_("copyright",game.defaults.lang), game);
 else if (game.Xsize*4-49 < 70)
	 string(L_("copyright",game.defaults.lang), game);
 else 
	 string(XL_("copyright",game.defaults.lang), game);
 }

void status::lost (the_board &game)
 {
 if (game.Xsize*4-49 < 30)
    string(S_("gameover",game.defaults.lang), game);
 else if (game.Xsize*4-49 < 70)
    string(M_("gameover",game.defaults.lang),game);
 else 
    string(L_("gameover",game.defaults.lang),game);
 } 

void status::won (the_board &game) {
 if (game.Xsize*4-49 < 30)
    string(S_("congratulations",game.defaults.lang), game);
 else if (game.Xsize*4-49 < 70)
    string(M_("congratulations",game.defaults.lang),game);
 else 
    string(L_("congratulations",game.defaults.lang),game);
}

void status::quest (the_board &game)
 {
 if (game.Xsize*4-49 < 30)
    string(S_("playagain?",game.defaults.lang), game);     
 else if (game.Xsize*4-49 < 70)
    string(M_("playagain?",game.defaults.lang), game);  
 else 
    string(L_("playagain?",game.defaults.lang), game); 
 } 
 
/* Copyright by FHF 2004 */
