/* ClassXY.C <-- class XY definitions. */

#include "classes.h"
#include "defines.h"
#include "../src/operations.h"

// Description of 'int how'
//   0 - move modulo
//   1 - move to the edge, then return -1
//   2 - work on Klein's Bottle
//   3 - work on Klein (do NOT change orient)

XY XY::move (the_board &game, int where, int how)
 {
 XY newXY;
 bool change = (how == 3) ? 0 : 1;
 how = (how==3) ? 2: how;
 newXY.x = x;
 newXY.y = y;
 where = where2pos (where, game);
 switch (how)
   {
   case 0:
     switch (where)
       { 
       case 1: incr(newXY.y,game.Ysize); decr(newXY.x,game.Xsize); break; 
       case 2: incr(newXY.y,game.Ysize); break;
       case 3: incr(newXY.y,game.Ysize); incr(newXY.x,game.Xsize); break;
       case 4: decr(newXY.x,game.Xsize); break;
       case 5: break;
       case 6: incr(newXY.x,game.Xsize); break;
       case 7: decr(newXY.y,game.Ysize); decr(newXY.x,game.Xsize); break;
       case 8: decr(newXY.y,game.Ysize); break;
       case 9: decr(newXY.y,game.Ysize); incr(newXY.x,game.Xsize); break;
       }
   break;
   case 1:
     switch (where)
       {
       case 1:
         if (newXY.x != 0 && newXY.y != game.Ysize-1) { newXY.x --; newXY.y ++; }
         else newXY = XY (-1,-1);
         break;
       case 2:
         if (newXY.y != game.Ysize-1) newXY.y ++;
         else newXY = XY (-1,-1);
         break;
       case 3:
         if (newXY.x != game.Xsize-1 && newXY.y != game.Ysize-1) { newXY.x ++; newXY.y ++; }
         else newXY = XY (-1,-1);    
         break;
       case 4:
         if (newXY.x != 0) newXY.x--;
         else newXY = XY (-1,-1);
       break;
       case 6:
         if (newXY.x != game.Xsize-1) newXY.x ++;
         else newXY = XY (-1,-1);
       break;
       case 7:
         if (newXY.x != 0 && newXY.y != 0) { newXY.x --; newXY.y --; }
         else newXY = XY (-1,-1);
         break;
       case 8:
         if (newXY.y != 0) newXY.y --;
         else newXY = XY (-1,-1);
       break;
       case 9:
         if (newXY.x != game.Xsize-1 && newXY.y != 0) { newXY.y --; newXY.x ++; }
         else newXY = XY (-1,-1);
       break;
       }
   break;       
   case 2:
     switch (where)
       {
       case 1:
         decr(newXY.x,game.Xsize); 
         if (newXY.y != game.Ysize-1) newXY.y ++;
         else 
	  {
	  if (change) game.orient = !game.orient;
	  newXY.y = 0;
	  newXY.x = game.Xsize - newXY.x -1;
	  }
         break;
       case 2:
         if (newXY.y != game.Ysize-1) newXY.y ++;
         else 
	  {
	  if (change) game.orient = !game.orient;
	  newXY.y = 0;
	  newXY.x = game.Xsize - newXY.x -1;
	  }
         break;	 
       case 3:
         incr(newXY.x,game.Xsize);
         if (newXY.y != game.Ysize-1) newXY.y ++;
         else 
	  {
	  if (change) game.orient = !game.orient;
	  newXY.y = 0;
	  newXY.x = game.Xsize - newXY.x -1;
	  }
         break;
       case 4: decr(newXY.x,game.Xsize); break;
       case 5: break;
       case 6: incr(newXY.x,game.Xsize); break;
       case 7:
	 decr(newXY.x,game.Xsize); 
         if (newXY.y != 0) newXY.y --;
         else 
	  {
	  if (change) game.orient = !game.orient;
	  newXY.y = game.Ysize - 1;
	  newXY.x = game.Xsize - newXY.x - 1;	  
	  }
         break;
       case 8:
         if (newXY.y != 0) newXY.y --;
         else 
	  {
	  if (change) game.orient = !game.orient;
	  newXY.y = game.Ysize - 1;
	  newXY.x = game.Xsize - newXY.x - 1;	  
	  }
       break;
       case 9:
	 incr(newXY.x,game.Xsize); 
         if (newXY.y != 0) newXY.y --;
         else 
	  {
	  if (change) game.orient = !game.orient;
	  newXY.y = game.Ysize - 1;
	  newXY.x = game.Xsize - newXY.x - 1;	  
	  }
       break;
       }
   break;       


   }
 return newXY;
 }

int XY::whereis (the_board &game)
 {
 if (x == 0 && y == 0) 			return 7;
 if (x == 0 && y == game.Ysize-1)	return 1;
 if (x == 0) 				return 4;

 if (x == game.Xsize-1 && y == game.Ysize-1) 	return 3;
 if (x == game.Xsize-1 && y == 0) 		return 9;
 if (x == game.Xsize-1) 			return 6;

 if (y == 0) 				return 8;
 if (y == game.Ysize-1) 		return 2;
					return 5;
 }

bool XY::operator ==(const XY XY_in)
 {
 if ( x == XY_in.x && y == XY_in.y ) return 1;
 return 0;
 }
 
/* Copyright by FHF 2004 */
