/* Classes.h */

#include <ncurses.h>
#include <time.h>

class box_type
  {
  public:
  int  num;
  bool seen;
  bool free;
  bool autorec;
  bool autorec2;
  box_type (void): num(0), seen(0), free(0), autorec(0) {};
  };
  
class the_board;

class XY
  {
  public:
  int x;
  int y;
  
  XY		(void)			{ x = 0; y = 0; };
  XY 		(int x_in, int y_in) 	{ x = x_in; y = y_in; };
  
  bool operator ==(const XY);
  int whereis	(the_board &);
  XY move	(the_board &, int, int);
  };


class defs
 {
 public:
 
 XY geometry;
 bool quit;
 int total;
 int ai;
 int surface; /* 1=euclid 2=klein 3=torus */
 int lang;    /* 1=english 2=polski */
 defs (void) { geometry = XY(-1,-1); total = -1; ai = -1; surface = -1; };
 void	make (the_board&);
 };


class status
 {
 public:
 WINDOW		*statuswin;
 void		make_all(the_board&);
 void		string(const char *, the_board&);
 void		make_basic(the_board&);
 void		time_update(the_board&);
 void		copyright(the_board&);
 void 		lost(the_board&); 
 void     	quest(the_board&);
 void		won(the_board&);
 
 protected:
 char		bas[40];
 char		ext[80];
 };

class the_board
  {
  public:

  int  num	(void);
  bool seen	(void);
  bool free	(void);
  bool autorec	(void);
  bool autorec2	(void);

  int  num	(XY);
  bool seen	(XY);
  bool free	(XY);
  bool autorec	(XY);  
  bool autorec2	(XY);  
  
  void num	(int);
  bool seen	(bool);
  void free	(bool);
  void autorec	(bool);  
  void autorec2	(bool);  
  void finish   (void);

  void num	(XY, int);
  bool seen	(XY, bool);
  void free	(XY, bool);
  void autorec	(XY, bool);  
  void autorec2	(XY, bool);  
  void force	(XY, bool);
  
  XY cursor;			// pozycja kursora
  time_t	start;		// czas startu + opoznienia
  defs 		defaults;	// dane na temat partii.
  status	footer;		
  bool generated;
  bool orient;			// orientacja przestrzeni
  int Xsize;
  int Ysize;
  int total;
  int uncovered;
  int cracked;
  bool			finished;

  the_board	(void) {};
  WINDOW* win	(void);
  WINDOW* win	(XY);

  void startwin		(void);
  void refresh_all	(void);
  void show_all		(void);
  bool pause		(void);
  void generate 	(void);
  void make		(int, int);
  void newstart		(void);
  void winner		(void);
  
  void bomb_free	(void);
  void bomb_check	(void);


  protected:
  WINDOW		***windows;
  box_type 		**board;
  void _bomb_check	(int);
  };
  
/* Copyright by FHF 2004 */
