/* Input.C <-- The stuff controlling keyboard  */

#include <stdio.h>
#include <termios.h>
#include <unistd.h>
#include <term.h>
#include <ncurses.h>

static termios first, current;
static int is_pressed = -1;

void open_keyboard (void)
 {
 tcgetattr(0, &first);
 current = first;
 current.c_lflag &= ~ICANON;
 current.c_lflag &= ~ECHO;
 current.c_lflag &= ~ISIG; 
 current.c_cc[VMIN] = 1; 
 current.c_cc[VTIME] = 0;
 tcsetattr(0, TCSANOW, &current);
 }
 
void close_keyboard (void)
 {
 tcsetattr(0, TCSANOW, &first);
 }

bool pressed_key (void)
 {
  char pressed;
  int  rread;
  
  if(is_pressed != -1) 
     return 1;

  current.c_cc[VMIN] = 0;
  tcsetattr(0, TCSANOW, &current);
  rread = read(0,&pressed,1);
  current.c_cc[VMIN] = 1;
  tcsetattr(0, TCSANOW, &current); 
  
  if(rread == 1) {
     is_pressed = pressed;
     return 1;
  }
  return 0;
 }

int supergetch (WINDOW *box_window)
 {
 char pressed;
 
 if(is_pressed != -1) {
    pressed = is_pressed;
    is_pressed = -1;
    return pressed;
 }
 read(0,&pressed,1);
 return pressed;
 }

 
int char_get (WINDOW *box_window)	// keyboard input
  {
  char pressed;
  
  pressed = supergetch (box_window);
  if (pressed == ' ') return 0;
  else if (pressed == 13) return 16;
  else if (pressed == 'L') return 32;
  else if (pressed == 'q') return 64;
  else if (pressed == 'p') return 128;
  else if (pressed == 'n'||pressed == 'N') return 254;
  else if (pressed == 'y'||pressed == 'Y') return 255;
  else if (pressed == 27) 
    { 
    if (pressed_key())
      {
      pressed=supergetch (box_window);
      if (pressed == 91)
        {
	if (pressed_key())
	  {
          pressed=supergetch(box_window);
          switch (pressed)
            {
            case 65: return 8; break;
            case 67: return 6; break;
            case 66: return 2; break;
            case 68: return 4; break;
            }
	  }    
        }
      }
     }
  else if (pressed > 48 && pressed < 58) return pressed-48;
  return -1;
}

void clean_buffer (WINDOW *win) {
	while (supergetch(win)!=-1) {};
}

/* Copyright by FHF 2004 */
